# $Id: OpenAL.m4,v 1.7 2004/01/03 16:48:54 erik Exp $
#

#
# AM_PATH_OPENAL([ACTION-IF-FOUND [,ACTION-IF-NOT-FOUND]])
#

AC_DEFUN(AM_PATH_OPENAL,
[
  AC_REQUIRE([AC_PROG_CC])
  AC_REQUIRE([AC_CANONICAL_TARGET])

  AL_CFLAGS=""
  AL_LIBS=""

  AC_LANG_SAVE
  AC_LANG_C

  AC_ARG_WITH(al-prefix,    
    [  --with-al-prefix=PFX     Prefix where OpenAL is installed],
    [
      AL_CFLAGS="-I$withval/include"
      AL_LIBS="-L$withval/lib"
    ])

  AC_ARG_WITH(al-includes,    
    [  --with-al-includes=DIR   where the OpenAL includes are installed],
    [
      AL_CFLAGS="-I$withval"
    ])

  AC_ARG_WITH(al-libraries,    
    [  --with-al-libraries=DIR  where the OpenAL libraries are installed],
    [
      AL_LIBS="-L$withval"
    ])

case "$target" in
	*-*-freebsd* | *-*-FreeBSD*)
		AL_LIBS="$AL_LIBS -pthread"
		;;
	*)
		AL_LIBS="$AL_LIBS -lpthread"
		;;
esac

  saved_CFLAGS="$CFLAGS"
  saved_LIBS="$LIBS"
  AC_LANG_SAVE
  AC_LANG_C
  have_AL=no

  exec 8>&AC_FD_MSG
dnl  exec AC_FD_MSG>/dev/null

case "$target" in
	*-apple-darwin*)
		AL_LIBS="-framework OpenAL"
		have_AL=yes
		;;
	*)
		AC_SEARCH_LIBS(alGenBuffers,
			[openal OpenAL32],
			[
				AL_LIBS="$LIBS"
				have_AL=yes
			], , $AL_LIBS)
		;;
esac

  LIBS="$saved_LIBS"
  CFLAGS="$saved_CFLAGS"

  exec AC_FD_MSG>&8
  AC_LANG_RESTORE

  if test "$have_AL" = "yes"; then
     ifelse([$1], , :, [$1])     
  else
     AL_CFLAGS=""
     AL_LIBS=""
     ifelse([$2], , :, [$2])
  fi
  AC_SUBST(AL_CFLAGS)
  AC_SUBST(AL_LIBS)
])

