# $Id: png.m4,v 1.2 2004/01/02 09:46:31 erik Exp $

#
# AM_PATH_PNG([ACTION-IF-FOUND [,ACTION-IF-NOT-FOUND]])
#

AC_DEFUN(AM_PATH_PNG,
[
  AC_REQUIRE([AC_PROG_CC])

  PNG_CFLAGS=""
  PNG_LIBS=""

  AC_LANG_SAVE
  AC_LANG_C

  AC_ARG_WITH(png-prefix,    
    [  --with-png-prefix=PFX     Prefix where PNG is installed],
    [
      PNG_CFLAGS="-I$withval/include"
      PNG_LIBS="-L$withval/lib"
    ])

  AC_ARG_WITH(png-includes,    
    [  --with-png-includes=DIR   where the PNG includes are installed],
    [
      PNG_CFLAGS="-I$withval"
    ])

  AC_ARG_WITH(png-libraries,    
    [  --with-png-libraries=DIR  where the PNG libraries are installed],
    [
      PNG_LIBS="-L$withval"
    ])

  saved_CFLAGS="$CFLAGS"
  saved_LIBS="$LIBS"
  AC_LANG_SAVE
  AC_LANG_C
  have_PNG=no

  exec 8>&AC_FD_MSG
dnl  exec AC_FD_MSG>/dev/null


  AC_CHECK_LIB(z, uncompress, AC_CHECK_LIB(png, png_create_info_struct, [
	PNG_LIBS="$PNG_LIBS -lpng -lz"
	have_PNG=yes
    ],,$PNG_LIBS))

  LIBS="$saved_LIBS"
  CFLAGS="$saved_CFLAGS"

  exec AC_FD_MSG>&8
  AC_LANG_RESTORE

  if test "$have_PNG" = "yes"; then
     ifelse([$1], , :, [$1])     
  else
     PNG_CFLAGS=""
     PNG_LIBS=""
     ifelse([$2], , :, [$2])
  fi
  AC_SUBST(PNG_CFLAGS)
  AC_SUBST(PNG_LIBS)
])

